class Menu 
    attr_reader :name, :desc_menus, :menu, :precios, :total
    def initialize(name, &block)
        @name = name
        @desc_menus = []
        @menu = []
        @precios = []
        @total=0

        if block_given?
          if block.arity == 1
        yield self
          else
           instance_eval(&block) 
          end
        end
    end

    def componente(bloque = {})
        @desc_menus << bloque[:descripcion]
        @menu << bloque[:platos]
        @precios << bloque[:precio]
    end
    def precio(coste)
        @total=coste[:precio]
        
    end

    def to_s
        text = @name + "\n"
        for i in 0..@desc_menus.length-1 do
            text << "\t- #{@desc_menus[i]}\n"
            text << "\t\t#{@menu[i]}"
            text <<"\n"
            text << "\t\t#{@precios[i]} €\n"
        end
        text<<"\n#{@total}"
        text
    end


end
