#Objeto que representa  un plato con multiples comidas 

class Plato
	attr_reader :lista, :cantidad,:nombre, :proteinas, :carbohidratos , :lipidos ,:calorias, :p_proteinas, :p_lipidos, :p_carbohidratos
	include Comparable	#incluimos el modulo Comparable

	def get_this
		return self
	end
	def initialize(lista_plato,lista_cantidad,nombre_plato)		# constructor que recibe la lista con alimentos, otra lista con la cantidad del alimento correspondiente y el nombre del plato
		@proteinas=@carbohidratos=@lipidos=@calorias=@p_calorias= @p_lipidos = @p_carbohidratos = @total = 0 	#inicializacmos todos los atributos a 0
		
		@lista = lista_plato 		#asignamos los atributos que tenemos 
		@nombre = nombre_plato
		@cantidad= lista_cantidad

		self.calc_proteina		#llamamos a los diferentes metedos para dar valor a los diferentes atributos
		self.calc_lipido
		self.calc_carbohidrato
		@total = @proteinas + @lipidos + @carbohidratos
		
		self.calc_porcentajes
		self.calc_calorias
	end
	

	def to_s		#damos formato del plato, siendo "Nombne, Alimento, Cantidad,......"
		@nombre = "#{@nombre}"
		contador =0
		 
		while (@lista[contador] != nil && @cantidad[contador] != nil) do 
			@nombre = @nombre + ",#{@lista[contador].get_valor.nombre},#{@cantidad[contador].get_valor}"
			contador = contador + 1
		end
		return @nombre
	end

	def calc_proteina		#metodo que calcula la proteinas del plato
		contador=0
		while( @lista[contador] != nil && @cantidad[contador] != nil)  do
			
			@proteinas=@proteinas + calcular_equivalente(@lista[contador].get_valor.proteinas,@cantidad[contador].get_valor)
			contador = contador +1
		end
		@proteinas
	end

	def calc_lipido		#metodo que calcula los lipidos del plato
		contador=0
		while( @lista[contador] != nil && @cantidad[contador] != nil)  do
			
			@lipidos=@lipidos + calcular_equivalente( @lista[contador].get_valor.lipidos , @cantidad[contador].get_valor )
			contador = contador +1
		end
		@lipidos
	end

	def calc_carbohidrato	#metodo que calcula los carbohidratos del plato
		contador=0
		while( @lista[contador] != nil && @cantidad[contador] != nil)  do
			
			@carbohidratos=@carbohidratos + calcular_equivalente( @lista[contador].get_valor.carbohidratos , @cantidad[contador].get_valor )
			contador = contador +1
		end
		@carbohidratos
	end
	def calc_calorias	#metodo que calcula las calorias totales del plato (Kcal)
		@calorias = (@proteinas*4 + @carbohidratos*9 + @lipidos*4).round(2)
		
	end

	def calc_porcentajes	# metodo que obtiene la proporcion de lipido,proteinas y carbohidratos de cada alimento
		@p_carbohidratos = ((@carbohidratos / @total)*100.0).round(2)
		@p_lipidos = ((@lipidos / @total)*100.0).round(2)
		@p_proteinas = ((@proteinas / @total)*100.0).round(2)
	end

	def calcular_equivalente(valor,cantidad)		# metodo que calcula el porcentaje de un valor cualquiera
		resultado=(valor * (cantidad / 100.0)).round(2)
		return resultado
	end

	def == (other)			# operador de comparacion
		if other.instance_of? Plato  		# solo compara si tenemos una instancia de Plato
		
		self.to_s == other.to_s 			# compara el formato en string de ambos objetos
		else			
			false
		end
	end

	def <=> (other) 					#operador <=> 
		
		if other.is_a? Plato 			#verificamos que sea una instancia de Plato
			return (self.calorias <=> other.calorias)  
		else  							# en cualquer otro caso retornamos nil
			return nil
		end

	end
	

end